"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Uow = /** @class */ (function () {
    function Uow() {
        this.creates = [];
        this.updates = [];
        this.deletes = [];
        this.isActive = false;
    }
    /**
     * release releases a transaction (should be overridden if needed)
     */
    Uow.prototype.release = function (tx) {
        return Promise.resolve();
    };
    /**
     * beginWork begins a transaction in this unit of work
     */
    Uow.prototype.beginWork = function () {
        this.isActive = true;
    };
    /**
     * commitWork commits all actions in this unit of work
     */
    Uow.prototype.commitWork = function () {
        return this.commitChanges();
    };
    /* protected */
    /**
     * markCreate caches object which is going to be created
     */
    Uow.prototype.markCreate = function (uowObj) {
        var _this = this;
        return this.mark(function () { return _this.creates.push(uowObj); });
    };
    /**
     * markUpdate caches object which is going to be updated
     */
    Uow.prototype.markUpdate = function (uowObj) {
        var _this = this;
        return this.mark(function () { return _this.updates.push(uowObj); });
    };
    /**
     * markDelete caches object which is going to be deleted
     */
    Uow.prototype.markDelete = function (uowObj) {
        var _this = this;
        return this.mark(function () { return _this.deletes.push(uowObj); });
    };
    /* private */
    Uow.prototype.mark = function (mark) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mark();
                        if (!!this.isActive) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.commitChanges()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Uow.prototype.commitChanges = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tx, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.begin()];
                    case 1:
                        tx = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 7, 9, 11]);
                        // for the possibility of multiple db manipulations in each commit,
                        // commits should wait for others to finish before continuing
                        return [4 /*yield*/, this.commitCreates(tx)];
                    case 3:
                        // for the possibility of multiple db manipulations in each commit,
                        // commits should wait for others to finish before continuing
                        _a.sent();
                        return [4 /*yield*/, this.commitUpdates(tx)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this.commitDeletes(tx)];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, this.commit(tx)];
                    case 6:
                        _a.sent();
                        return [3 /*break*/, 11];
                    case 7:
                        e_1 = _a.sent();
                        return [4 /*yield*/, this.rollback(tx)];
                    case 8:
                        _a.sent();
                        throw e_1;
                    case 9: return [4 /*yield*/, this.release(tx)];
                    case 10:
                        _a.sent();
                        this.dispose();
                        return [7 /*endfinally*/];
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    Uow.prototype.commitCreates = function (tx) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(this.creates.map(function (m) { return m.createByTx(tx); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Uow.prototype.commitUpdates = function (tx) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(this.updates.map(function (m) { return m.updateByTx(tx); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Uow.prototype.commitDeletes = function (tx) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(this.deletes.map(function (m) { return m.deleteByTx(tx); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Uow.prototype.dispose = function () {
        this.creates = [];
        this.updates = [];
        this.deletes = [];
        this.isActive = false;
    };
    return Uow;
}());
exports.Uow = Uow;
//# sourceMappingURL=index.js.map